#include "tab.h"
#include "bitmap.h"

void addRecentFileList(void);
void cleanup(void);
RGBTRIPLE COLORREFtoRGB(long);
BYTE confirmClose(void);
void decompress(int,BYTE*);
Tab *getSelectedTab(void);
void getIntPal(RGBTRIPLE,BYTE *,BYTE *);
RGBTRIPLE getRGBTRIPLE(BYTE,BYTE);
int initTab(void);
void initProgram(void);
int initWindow(void);
RGBTRIPLE makeRGBTRIPLE(BYTE,BYTE,BYTE);
BYTE openROM(BYTE=255);
bool saveROM(void);
void switchToTab(BYTE);
char tileChar(BYTE);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

inline int mem2ROM(int address)
	{ return address - 0xC00000 + 0x200; }
inline bool overlapRect(RECT r,RECT r2)
	{ if(r.bottom < r2.top) return false;
	  if(r.top > r2.bottom) return false;
	  if(r.left > r2.right) return false;
	  if(r.right < r2.left) return false;
	  return true; }
inline long RGBtoCOLORREF(RGBTRIPLE c)
	{ long color; color = c.rgbtRed; color += c.rgbtGreen * 256; color += c.rgbtBlue * 65536;
	  return color; }
inline int ROM2mem(int address)
	{ return address + 0xC00000 - 0x200; }

#define SAFE_DELETE(p)  { if(p) { delete (p);     (p)=NULL; } }

#define inRect(a,b,r) ((r.top <= b) && (r.bottom >= b) && (r.left <= a) && (r.right >= a))

#define BIT(a) ((1 << (a)))

extern HINSTANCE hInst;
extern HWND hWnd;
extern HWND hMainTab;
extern HWND hDlg;

extern HDC screenHdc;

extern char ff3seTitle[80];

extern HCURSOR brushCursor;
extern HCURSOR eraseCursor;
extern HCURSOR grabCursor;

extern Bitmap backBmp,back2Bmp;

extern bool ROMchanged;

extern char ROMname[1024];

extern int tabSelected;

