#include "bitmap.h"

class Portrait
	{
	public:

	Bitmap pic;

	void changePalette(BYTE);
	void clear(void);
	void copy(BYTE);
	void flipImage(int);
	void load(BYTE *);
	void save(int);
	void setImage(Bitmap&);			
	void setTransparency(BYTE);
	void updatePalette(void);

	//Inline functions
	
	inline int getPalNum(void)
		{ return palette; }
	inline BYTE getPixel(int x,int y)
		{ return pic.getPixel(x,y); }
	inline void setPalette(BYTE p)
		{ palette = p; }
	inline void setPixel(int x,int y,BYTE c)
		{ pic.setPixel(x,y,c); }
	private:

	BYTE image[800];

	BYTE palette;
	
	};

bool loadPortraits(char*);
void loadPortraitPals(int handle);
bool savePortraits(char*);
void savePortraitPals(int);

extern Portrait portrait[19];
extern RGBTRIPLE portraitPals[19][16];

