#include "stdafx.h"

#include "tab.h"

/*************************************/
//Returns the Tab's handle
HWND Tab::getHandle(void)
	{
	return hTab;
	}

/*************************************/
//Hides the tab
void Tab::hide(void)
	{
	ShowWindow(hTab,SW_HIDE);
	}

/*************************************/
//Redraws the tab when a new ROM is loaded
void Tab::newROM(void)
	{
	invalidateTab();
	}

/*************************************/
//Shows the tab
void Tab::show(void)
	{
	BringWindowToTop(hTab);
	ShowWindow(hTab,SW_NORMAL);
	}

/*************************************/
//Invalidates the entire tab causing it to be redrawn
void Tab::invalidateTab(void)
	{
	RECT r;

	GetClientRect(hTab,&r);
	InvalidateRect(hTab,&r,false);
	}

/*************************************/
//Invalidates a specific control on the tab causing it to be redrawn
void Tab::invalidateTabControl(int control)
	{
	RECT r,r2,r3;
	HWND hCtrl;

	hCtrl = GetDlgItem(hTab,control);
	
	GetWindowRect(hTab,&r);
	GetWindowRect(hCtrl,&r2);

	r3.bottom = r2.bottom - r.top;
	r3.left = r2.left - r.left;
	r3.right = r2.right - r.left;
	r3.top = r2.top - r.top;

	InvalidateRect(hTab,&r3,false);
	}
