#include "bitmap.h"
#include "tab.h"

class Tab1 : public Tab
	{
	public:

	~Tab1(void);
	
	void create(void);
	void import(void);
	void initTab(void);
	void newROM(void);
	bool save(char*);
	void switchType(void);

	friend UINT CALLBACK tab1HookProc(HWND, UINT, WPARAM, LPARAM);
	friend BOOL CALLBACK tab1Proc(HWND, UINT, WPARAM, LPARAM);
	friend BOOL CALLBACK copyMonsterProc(HWND, UINT, WPARAM, LPARAM);

	private:

	int monsSelected;
	BYTE palEntrySelected;
	BYTE palWidth;
	BYTE buttonSelected;
	bool monsChanged;
	BYTE magnification;

	HDC monsHdc,editHdc;
	HBITMAP monsBMP,editBMP;

	void addNames(void);
	void brushButton(int,int);
	void changeImage(void);
	void changeNumColors(void);
	void changePalette(void);
	void changePalEntry(BYTE);
	void changeSize(void);
	void changeTransparency(void);
	void clearImage(void);
	void copyImage(void);
	bool copyImageProc(HWND, UINT, WPARAM, LPARAM);
	void createHDCs(void);
	void createImageList(void);
	void displayPreview(HWND);
	void drawPaintButtons(WPARAM,LPARAM);
	void drawTab(void);
	void eraseButton(int,int);
	void exportImage(void);
	void flipImage(int);
	void handleMagScroll(int,HWND,int);
	void handleMouseClick(int,int);
	void handleMouseMove(int,int,bool);
	void handleSliders(WPARAM,LPARAM);
	void invalidateMonsterPics(void);
	void invalidatePics(void);
	void newImage(void);
	void newSelection(void);
	void selectButton(BYTE);
	void setCursor(void);
	void sliderEnable(void);
	void updateControls(void);
	BOOL tabProc(HWND, UINT, WPARAM, LPARAM);
	UINT tab1HookProc(HWND, UINT, WPARAM, LPARAM);
	};

UINT CALLBACK tab1HookProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK copyMonsterProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK tab1Proc(HWND, UINT, WPARAM, LPARAM);

extern Tab1 tab1;

