#include "tab.h"

class Tab3 : public Tab
	{
	public:

	~Tab3(void);
	
	void create(void);
	void import(void);
	void initTab(void);
	bool save(char*);

	friend BOOL CALLBACK tab3Proc(HWND, UINT, WPARAM, LPARAM);
	friend BOOL CALLBACK copyPortraitProc(HWND,UINT,WPARAM,LPARAM);
	friend UINT CALLBACK tab3ImportProc(HWND,UINT,WPARAM,LPARAM);

	private:

	HDC portHdc,editHdc;
	HBITMAP portBMP,editBMP;

	BYTE buttonSelected;
	BYTE portSelected;
	BYTE magnification;
	BYTE palEntrySelected;
		
	void addNames(void);
	void brushButton(int,int);
	void changePalEntry(BYTE);
	void changePalette(void);
	void changeTransparency(void);
	bool copyImageProc(HWND,UINT,WPARAM,LPARAM);
	void copyPortrait(void);
	void clearImage(void);
	void createHDCs(void);
	void drawPaintButtons(WPARAM,LPARAM);
	void displayPreview(HWND);
	void drawTab(void);
	void eraseButton(int,int);
	void exportImage(void);
	void flipImage(int);
	void handleMagScroll(int,HWND,int);
	void handleMouseClick(int,int);
	void handleMouseMove(int,int,bool);
	void handleSliders(WPARAM,LPARAM);
	UINT importProc(HWND,UINT,WPARAM,LPARAM);
	void invalidatePics(void);
	void newSelection(void);
	void selectButton(BYTE);
	void setCursor(void);
	void sliderEnable(void);
	void updateControls(void);

	BOOL tabProc(HWND, UINT, WPARAM, LPARAM);
	};

BOOL CALLBACK tab3Proc(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK copyPortraitProc(HWND,UINT,WPARAM,LPARAM);
UINT CALLBACK tab3ImportProc(HWND,UINT,WPARAM,LPARAM);

extern Tab3 tab3;

